# -*- coding: UTF-8 -*-

require_relative  'send_util'
require_relative  '../config'
require_relative  '../vo/response'
require 'digest'
require "json"

#发送短信module
module SendSmsModule

  #发送短信
  def send_sms(sms,sms_key)
    #验证参数(简单的参数验证,详情参考api文档,或根据业务需求自行校验)
    if sms.nil?
      return  Response.new(false,"","sms can not be nil","")
    end
    if sms_key.nil? || sms_key.empty?
      return  Response.new(false,"","sms_key can not be nil or empty","")
    end
    if sms.smsUser.empty?
      return Response.new(false,"","smsUser can not be empty","")
    end
    if sms.templateId.empty?
      return Response.new(false,"","templateId can not be empty","")
    end
    if sms.phone.empty?
      return  Response.new(false,"","phone can not be empty","")
    end

    #开始发送
    param_hash = {}
    begin
      #填充发送参数
      sms.instance_variables.each { |item|
        param_hash[item.slice(1,item.size)] =  sms.instance_variable_get(item)
      }

      #计算签名signature
      param_hash["signature"]= md5(param_hash,sms_key)

      #发送
      res=JSON.parse(SendUtil.send_post(Config::SEND_SMS,param_hash))
      #puts res

    rescue
      puts "error:#{$!} at:#{$@}"
      return Response.new(false,"","send sms fail","")
    end

    #发送结果
    return Response.new(res["result"],res["statusCode"],res["message"],res["info"])
  end
  
  #发送语音
  def send_voice(sms,sms_key)
    #验证参数(简单的参数验证,详情参考api文档,或根据业务需求自行校验)
    if sms.nil?
      return  Response.new(false,"","sms can not be nil","")
    end
    if sms_key.nil? || sms_key.empty?
      return  Response.new(false,"","sms_key can not be nil or empty","")
    end
    if sms.smsUser.empty?
      return Response.new(false,"","smsUser can not be empty","")
    end
    if sms.code.empty?
      return Response.new(false,"","code can not be empty","")
    end
    if sms.phone.empty?
      return  Response.new(false,"","phone can not be empty","")
    end

    #开始发送
    param_hash = {}
    begin
       #填充发送参数
      sms.instance_variables.each { |item|
        param_hash[item.slice(1,item.size)] =  sms.instance_variable_get(item)
      }

      #计算签名signature
      param_hash["signature"]= md5(param_hash,sms_key)


      #发送
      res=JSON.parse(SendUtil.send_post(Config::SEND_VOICE,param_hash))
      #puts res

    rescue
      puts "error:#{$!} at:#{$@}"
      return Response.new(false,"","send sms fail","")
    end

    #发送结果
    return Response.new(res["result"],res["statusCode"],res["message"],res["info"])
  end

  #计算signature
  def md5(params,sms_key)
    #参数根据key 排序
    new_param_hash=Hash[params.sort_by{|key, val|key}]
    #参数拼接
    p=String.new(sms_key)
    new_param_hash.each {|key, value|  p= p + "&"+key+"=" + value}
    p = p +"&" + sms_key
    #参数加密
    return Digest::MD5.hexdigest(p)
  end
end
